import { Base, Type, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { CategoryMode } from "./CategoryMode";
import { FramePreparer } from "./FramePreparer";
import { IIsCategoryBased } from "./IIsCategoryBased";
import { List$1 } from "igniteui-react-core";
import { ISupportsMarkers } from "./ISupportsMarkers";
import { IProvidesViewport } from "./IProvidesViewport";
import { ISupportsErrorBars } from "./ISupportsErrorBars";
import { CategoryFrame } from "./CategoryFrame";
import { IDetectsCollisions } from "./IDetectsCollisions";
import { PreparationParams } from "./PreparationParams";
import { Frame } from "./Frame";
import { ICategoryScaler } from "./ICategoryScaler";
import { ValuesHolder } from "./ValuesHolder";
import { NumericAxisBase } from "./NumericAxisBase";
import { IHasCategoryTrendline } from "./IHasCategoryTrendline";
import { IHasSingleValueCategory } from "./IHasSingleValueCategory";
import { MarkerSeries } from "./MarkerSeries";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { ICategorySeriesInteractionManager } from "./ICategorySeriesInteractionManager";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { Marker } from "./Marker";
import { MarkerSeriesView } from "./MarkerSeriesView";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { AssigningCategoryMarkerStyleEventArgs } from "./AssigningCategoryMarkerStyleEventArgs";
import { SeriesComponentsForView } from "./SeriesComponentsForView";
import { Pool$1 } from "igniteui-react-core";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { RenderSurface } from "./RenderSurface";
import { Clipper } from "igniteui-react-core";
/**
 * @hidden
 */
export declare class CategoryBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected c: CategorySeriesView;
    constructor(a: CategorySeriesView);
    e: number;
    f: number;
    d: number;
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    g(a: number): void;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class CategoryFramePreparerBase extends FramePreparer {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    g: IBucketizer;
    h: IIsCategoryBased;
    protected abstract l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    m: boolean;
    private i;
    r(a: ICategoryScaler, b: Rect, c: Rect, d: Rect): number;
    private s;
    d(a: Frame, b: SeriesView): void;
    protected v(a: CategoryFrame, b: SeriesView): void;
    private o;
    protected readonly q: List$1<number[]>;
    private p;
    private n;
    protected t(a: PreparationParams, b: ValuesHolder, c: number, d: boolean, e: boolean): number;
    protected k(): boolean;
    protected abstract z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected abstract u(a: ValuesHolder, b: number, c: boolean): void;
    protected abstract e(a: number, b: ValuesHolder): number[];
    protected f(a: PreparationParams, b: number, c: ValuesHolder, d: number, e: boolean, f: number[], g: number): {
        ret: number[];
        p1?: number;
        p4: boolean;
        p5: number[];
    };
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected abstract x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected abstract j(a: PreparationParams): ValuesHolder;
}
/**
 * @hidden
 */
export declare class CategoryFramePreparer extends CategoryFramePreparerBase {
    static $t: Type;
    constructor(a: number, b: IIsCategoryBased);
    constructor(a: number, b: IIsCategoryBased, c: ISupportsMarkers, d: IProvidesViewport, e: ISupportsErrorBars, f: IBucketizer);
    constructor(a: number, ..._rest: any[]);
    private aa;
    private ab;
    protected ac: IHasCategoryTrendline;
    protected ad: IHasSingleValueCategory;
    protected l(a: CategoryFrame, b: number[], c: IDetectsCollisions, d: number, e: number, f: number): boolean;
    protected j(a: PreparationParams): ValuesHolder;
    protected x(a: PreparationParams, b: number[], c: number, d: boolean, e: ScalerParams, f: ScalerParams): void;
    protected y(a: PreparationParams, b: number, c: boolean, d: ScalerParams, e: ScalerParams, f: boolean, g: boolean): void;
    protected w(a: PreparationParams, b: ValuesHolder, c: number): void;
    protected z(a: ValuesHolder, b: number, c: boolean, d: boolean): void;
    protected u(a: ValuesHolder, b: number, c: boolean): void;
    protected e(a: number, b: ValuesHolder): number[];
}
/**
 * @hidden
 */
export declare abstract class CategorySeries extends MarkerSeries implements IHasCategoryModePreference, ISupportsErrorBars {
    static $t: Type;
    pz: CategoryFramePreparer;
    protected bp(): SeriesView;
    p3: CategorySeriesView;
    private qc;
    readonly qd: ICategorySeriesInteractionManager;
    ct(a: List$1<SeriesPointOfInterest>, b: boolean, c: number): boolean;
    private qy;
    kk(a: SeriesView): void;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    readonly categoryAxis: CategoryAxisBase;
    pu(): CategoryAxisBase;
    qe(): NumericAxisBase;
    protected get_cz(): boolean;
    constructor();
    ac(): void;
    qk: boolean;
    qj: boolean;
    protected qg: boolean;
    protected qf: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    assigningCategoryMarkerStyle: (sender: any, args: AssigningCategoryMarkerStyleEventArgs) => void;
    qm(): boolean;
    protected qn(): boolean;
    protected rb(a: AssigningCategoryStyleEventArgs): void;
    protected ra(a: AssigningCategoryMarkerStyleEventArgs): void;
    po(a: number, b: number): any[];
    jl(a: boolean, b: SeriesView): void;
    bb(): SeriesComponentsForView;
    j2(): void;
    qp: boolean;
    protected lo(a: Rect, b: Rect): void;
    p5: CategoryTransitionInMode;
    ql: boolean;
    protected ln(a: Rect, b: Rect): void;
    protected kp(a: any, b: string, c: any, d: any): void;
    protected qi(): boolean;
    protected qh(): boolean;
    qs(a: Point): number;
    protected get_dg(): boolean;
    aq(): CategoryAxisBase;
    gb(a: Point): number;
    abstract getOffsetValue(): number;
    abstract getCategoryWidth(): number;
    gq(a: Point): any;
    f9(a: Point): number;
    e4(a: Point): number;
    private qa;
    private qb;
    av(a: any, b: Point, c: boolean): HighlightingInfo;
    protected get_da(): boolean;
    jj(): void;
    au(a: any, b: Point, c: boolean): HighlightingInfo;
    protected qr(): List$1<Marker>;
    protected p9(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected p8(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected p7(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    pw: CategoryFrame;
    py: CategoryFrame;
    pv: CategoryFrame;
    px: CategoryFrame;
    p2: CategorySeriesRenderManager;
    protected q7(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    q8(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    ec(a: Rect, b: Rect, c: SeriesView): boolean;
    private qq;
    protected dt(): boolean;
    protected p4(): CategoryTransitionInMode;
    p6: CategoryTransitionSourceFramePreparer;
    protected jm(): void;
    k4(a: boolean): void;
    protected b2(): TransitionInSpeedType;
    protected qt(): number;
    qx(): number;
    readonly GetErrorBarsXAxis: Axis;
    readonly GetErrorBarsYAxis: Axis;
    q6(a: CategorySeriesView, b: CategoryFrame): void;
    rc(a: CategoryFrame, b: CategorySeriesView): void;
    q9(a: CategoryFrame, b: CategorySeriesView): void;
    qu(a: SeriesView): number;
    qv(a: SeriesView): number;
    qw(a: SeriesView): number;
    q5(a: SeriesView): void;
    k5(a: Rect, b: RenderSurface): void;
    rd(): void;
    abstract fetchXAxis(): Axis;
    abstract fetchYAxis(): Axis;
    abstract qo(): boolean;
    p0(a: CategorySeriesView): CategoryFramePreparer;
    am(a: Axis): Axis;
    ag(): Axis[];
    static pp(a: List$1<number[]>, b: number, c: Rect, d: Rect, e: boolean): Clipper;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class CategorySeriesView extends MarkerSeriesView implements ISupportsMarkers {
    static $t: Type;
    ct: CategorySeries;
    cw: number;
    cv(a: CategoryFrame): boolean;
    cy(a: CategoryFrame): void;
    constructor(a: CategorySeries);
    updateMarkerTemplate(a: number, b: number, c: number): void;
    cr: CategoryBucketCalculator;
    cs(): CategoryBucketCalculator;
    cu: Pool$1<Marker>;
    readonly shouldDisplayMarkers: boolean;
    updateMarkerCount(a: number): void;
    cf(a: (arg1: Marker) => void): void;
    cx(): void;
}
